<template>
  <v-select
    v-bind="$attrs"
    :items="mappedItems"
    :placeholder="$t('placeholder')"
    clearable
    v-on="$listeners"
  >
    <template v-slot:item="props">
      <slot
        v-bind="props"
        name="item"
      >
        {{ props.item.text }}
      </slot>
    </template>
  </v-select>
</template>

<script>
  import { mapperItemsToSelectField } from '../../mappers/mapperItemsToSelectField'

  export default {
    name: 'SelectField',
    props: {
      items: {
        type: Array,
        required: true,
      },
      textKey: {
        type: String,
        required: false,
        default: 'title',
      },
      valueKey: {
        type: String,
        required: false,
        default: 'id',
      },
      colorKey: {
        type: String,
        required: false,
        default: 'color',
      },
    },
    computed: {
      mappedItems () {
        return mapperItemsToSelectField(this.items, this.textKey, this.valueKey, this.colorKey)
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          placeholder: 'Selecione um item da lista',
        },
        'en-US': {
          placeholder: 'Select an item from the list',
        },
      },
    },
  }
</script>
